local GROUND=GLOBAL.GROUND
local TUNING=GLOBAL.TUNING
PrefabFiles = {
  "smart_paver",
   "smart_pf_plus",
}

Assets = {

  Asset( "IMAGE", "images/inventoryimages/puluji.tex" ),
  Asset( "ATLAS", "images/inventoryimages/puluji.xml" ),
  Asset( "IMAGE", "images/inventoryimages/smartpfp.tex" ),
  Asset( "ATLAS", "images/inventoryimages/smartpfp.xml" ),
  Asset("ANIM", "anim/puluji.zip"),
   Asset("ANIM", "anim/swap_puluji.zip"),
    Asset("ANIM", "anim/smartpfp.zip"),
   Asset("ANIM", "anim/swap_smartpfp.zip"),
}

local STRINGS = GLOBAL.STRINGS
local RECIPETABS = GLOBAL.RECIPETABS
local Recipe = GLOBAL.Recipe
local Ingredient = GLOBAL.Ingredient
local TECH = GLOBAL.TECH

local adminmode=GetModConfigData("adminmode")

if GetModConfigData("Language") == false then
STRINGS.NAMES.SMART_PAVER = "SmartPaver"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SMART_PAVER = "MDZZ"
STRINGS.RECIPE_DESC.SMART_PAVER = "I  sure  you  will  like  it"

STRINGS.NAMES.SMART_PF_PLUS = "Smartpitchfork"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SMART_PF_PLUS = "MDZZ"
STRINGS.RECIPE_DESC.SMART_PF_PLUS = "Use  it"
end
if GetModConfigData("Language") == true then
STRINGS.NAMES.SMART_PAVER = "铺路机"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SMART_PAVER = "自动铺路"
STRINGS.RECIPE_DESC.SMART_PAVER = "我确定你会喜欢上它"

STRINGS.NAMES.SMART_PF_PLUS = "挖掘机"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SMART_PF_PLUS = "自动挖地皮"
STRINGS.RECIPE_DESC.SMART_PF_PLUS = "使用它"

end

local smart_pf_plus = GLOBAL.Recipe("smart_pf_plus", {Ingredient("twigs", 3),Ingredient("flint", 3)}, GLOBAL.RECIPETABS.TOOLS, GLOBAL.TECH.NONE)
smart_pf_plus.atlas = "images/inventoryimages/smartpfp.xml"
smart_pf_plus.image = "smartpfp.tex"

local smart_paver = GLOBAL.Recipe("smart_paver", {Ingredient("twigs", 3),Ingredient("flint", 3)}, GLOBAL.RECIPETABS.TOOLS, GLOBAL.TECH.NONE)
smart_paver.atlas = "images/inventoryimages/puluji.xml"
smart_paver.image = "puluji.tex"

 TUNING.MOD_GROUND={}

local turfname = 0
local turftgp= 0
for _, moddir in ipairs(GLOBAL.KnownModIndex:GetModsToLoad()) do
	if GLOBAL.KnownModIndex:GetModInfo(moddir).name == "Turfed!" or GLOBAL.KnownModIndex:GetModInfo(moddir).name == "创意地皮" then
		turfname = 1
	end 
end
for _, moddir in ipairs(GLOBAL.KnownModIndex:GetModsToLoad()) do
	if  GLOBAL.KnownModIndex:GetModInfo(moddir).name == "创意地皮" and GLOBAL.KnownModIndex:GetModInfo(moddir).version=="1.0"  then
		turftgp = 1
	end 
end
AddPrefabPostInit("world",function(inst)
	inst:DoTaskInTime(1,function()
	if turfname == 1 then
		TUNING.MOD_GROUND = {
			[GROUND.MODTEST] = "turf_test",
			[GROUND.CARPETBLACKFUR] = "turf_carpetblackfur",
			[GROUND.CARPETBLUE] = "turf_carpetblue",
			[GROUND.CARPETCAMO] = "turf_carpetcamo",
			[GROUND.CARPETFUR] = "turf_carpetfur",
			[GROUND.CARPETPINK] = "turf_carpetpink",
			[GROUND.CARPETPURPLE] = "turf_carpetpurple",
			[GROUND.CARPETRED] = "turf_carpetred",
			[GROUND.CARPETRED2] = "turf_carpetred2",
			[GROUND.CARPETTD] = "turf_carpettd",
			[GROUND.CARPETWIFI] = "turf_carpetwifi",
			[GROUND.NATUREASTROTURF] = "turf_natureastroturf",
			[GROUND.NATUREDESERT] = "turf_naturedesert",
			[GROUND.ROCKBLACKTOP] = "turf_rockblacktop",
			[GROUND.ROCKGIRAFFE] = "turf_rockgiraffe",
			[GROUND.ROCKMOON] = "turf_rockmoon",
			[GROUND.ROCKYELLOWBRICK] = "turf_rockyellowbrick",
			[GROUND.TILECHECKERBOARD] = "turf_tilecheckerboard",
			[GROUND.TILEFROSTY] = "turf_tilefrosty",
			[GROUND.TILESQUARES] = "turf_tilesquares",
			[GROUND.WOODCHERRY] = "turf_woodcherry",
			[GROUND.WOODDARK] = "turf_wooddark",
			[GROUND.WOODPINE] = "turf_woodpine",
			[GROUND.SPIKES] = "turf_spikes",
		}
	end
	
	end)

end)
if turftgp == 1 then
		
AddComponentPostInit("terraformer", function(self)

	local function SpawnTurf(turf, pt)
		if turf ~= nil then
			local loot = GLOBAL.SpawnPrefab("turf_"..turf.name)
			loot.Transform:SetPosition(pt:Get())
			if loot.Physics ~= nil then
				local angle = math.random() * 2 * GLOBAL.PI
				loot.Physics:SetVel(2 * math.cos(angle), 10, 2 * math.sin(angle))
			end
		end
	end
	local GroundTiles = GLOBAL.require("worldtiledefs")
	local _Terraform = self.Terraform

	self.Terraform = function(self, pt)

		local world = GLOBAL.TheWorld
		local map = world.Map
		if not map:CanTerraformAtPoint(pt:Get()) then
			return false
		end
		local original_tile_type = map:GetTileAtPoint(pt:Get())

		local ret = _Terraform(self, pt)
		if ret == true then

			local turf_prefab = GroundTiles.turf[original_tile_type] 
			if turf_prefab ~= nil then
				SpawnTurf(turf_prefab, pt)
			end
			return true
		end
		return false
	end
end)
end



local _G = GLOBAL
local TheNet = _G.TheNet
local IsServer = TheNet:GetIsServer() or TheNet:IsDedicated()

if IsServer and adminmode then
local old_BUILD = _G.ACTIONS.BUILD.fn
	_G.ACTIONS.BUILD.fn = function(act)
		if _G.TheWorld.ismastersim == false then return old_BUILD(act) end
		if act.recipe  and (act.recipe=="smart_paver" or act.recipe=="smart_pf_plus") then
			if act.doer.Network:IsServerAdmin() then
				return old_BUILD(act)
			else
				act.doer:DoTaskInTime(0.01,function()
					act.doer.components.talker:Say("只允许管理员制作铺路机和挖路机！")
				end)
				return false
			end
		end
	return old_BUILD(act)
	end
end